\input Head

\section{\tt State}

% A short (preferably one-line) description of {\tt MyClass}.

Abstract base class for all objects representing algorithm internal states.

\subsection{User Interface}

% The class definition from the header file

\begin{verbatim}

namespace datacondAPI
{
    class State : public udt
    {
    };

} // namespace datacondAPI

\end{verbatim}

\subsection{Description}

% A longer description of what {\tt MyClass} is used for.

{\tt State} exists solely to organise the conecptually related derived state
types.  It does not provide any additional functionality.

\subsection{Operating Instructions}

\subsubsection{Example Usage}

% A verbatim block of example code showing proper usage of {\tt
% MyClass}.

As an abstract base class, the only valid use of {\tt State} is to inherit 
from it.

\begin{verbatim}

namespace datacondAPI
{
  
  class MixerState : public State
  {
    
    friend class Mixer;
    
  public:
    
    // constructors
    
    //: construct from phase, frequency
    //!param: phase - phase of Mixer at first (current) sample
    //!param: freq - local oscillator frequency Nyquist frequency units
    //!exc: std::domain_error - condition?
    //!todo: check exceptions
    MixerState(const double& phase, const double& freq) 
      throw(std::domain_error);

    //: construct from phase, frequency as udts
    //!param: phase - phase of Mixer at first (current) sample
    //!param: freq - local oscillator frequency Nyquist frequency units
    //!exc: std::domain_error - condition?
    //!exc: std::invalid_argument - condition?
    //!todo: check exceptions
    MixerState(const udt& phase, const udt& freq) 
      throw(std::domain_error, std::invalid_argument);

    //: Copy constructor
    //!param: state - MixerState to construct from
    MixerState(const MixerState& state) throw();

    //: Construct from MixerState as udt
    //!param: state - MixerState to construct from 
    //!exc: std::invalid_argument - state not of type MixerState
    MixerState(const udt& state) throw(std::invalid_argument);
    
    // destructor
    //: Destructor
    virtual ~MixerState() throw();
    
    // assignment
    
    //: assignment operator
    //!param: state - MixerState to assign from
    MixerState& operator=(const MixerState& state) throw();
    
    // accessors
    
    //: phase at current sample
    //!return: double - phase at current sample
    double GetPhase() const throw();

    //: frequency of local oscillator
    //!return: double - frequency of local oscillator as fraction of Nyquist
    //+ sampling frequency
    double GetFrequency() const throw();

    // UDT methods
    //: create duplicate object
    datacondAPI::MixerState* Clone() const;

    //: convert *this to an ILWD
    //!param: Chain - 
    //!param: Target -
    //!return: ILwd::LdasElement* - 
    ILwd::LdasElement* ConvertToIlwd( const CallChain& Chain, datacondAPI::udt::target_t Target = datacondAPI::udt::TARGET_GENERIC ) const;

    //!return: bool - true if MixerState is valid
    bool IsValid() const;
    
  private:
    
    //: set state phase
    //!param: phase - new state phase
    //!exc: std::invalid_argument - ????
    void SetPhase(const double& phase) throw(std::domain_error);

    //: set state phase
    //!param: phase - new state phase
    //!exc: std::domain_error - phase not a Scalar<double>
    //!exc: std::invalid_argument - ????
    void SetPhase(const udt& phase) 
      throw(std::domain_error, std::invalid_argument);

    //: set local oscillator frequency
    //!param: phase - new local oscillator frequency in units of Nyquist freq
    //!exc: std::domain_error - |freq| > 1
    void SetFrequency(const double& freq) throw(std::domain_error);

    //: set local oscillator frequency
    //!param: freq - new local oscillator frequency in units of Nyquist freq
    //!exc: std::domain_error - |freq| > 1
    //!exc: std::invalid_argument - freq is not a Scalar<>
    void SetFrequency(const udt& freq) 
      throw(std::domain_error, std::invalid_argument);
    
    //: default constructor
    //!todo: why is this prohibited?
    MixerState();
    
    // member data
    
    double m_phase;
    double m_frequency;
    
  }; // class MixerState
  
} // namespace datacondAPI

\end{verbatim}

\subsubsection{Options/Defaults}

% A list of options or defaults for public methods or member data of
% {\tt MyClass}. 

None.

\subsection{Exceptions}

\subsubsection{Exceptions Thrown}

% A list of exceptions thrown by {\tt MyClass}.

None.  Note though that there are no exception specifications, so methods provided by derived classes may throw exceptions of any type.

\subsubsection{Exceptions Handled}

% A list of exceptions handled by {\tt MyClass}.

None.

\subsection{Algorithms}

% A discussion of the algorithms used by {\tt MyClass}.

None.

\subsection{Accuracy}

% A discussion of issues related to the accuracy of numerical routines
% used by {\tt MyClass}---e.g., approximations,  argument ranges, etc.

Not relevant.

\subsection{Performance}

% A discussion of issues related to the speed (e.g., $O(N\log N)$) of
% computationally demanding routines used by {\tt MyClass}.

Not relevant.

\subsection{Testing}

% A description of any test code/test classes that were used to test
% {\tt MyClass}. 

{\tt State} is implictly tested by the testing of its derived types.

\subsection{Notes}

% Miscellaneous notes about {\tt MyClass} that do not appear
% elsewhere, things that remain to be done, etc.  

{\tt State} is purely an organisational convenience.

\subsection{See Also}

% A list of derived classes, base classes, etc.\ closely related to
% {\tt MyClass}. 

\subsubsection{Base Classes}
{\tt UDT}.

\subsubsection{Derived Classes}
All state types.

\subsection{References}

% A list of references for any algorithms, etc.\ used by {\tt
% MyClass}. 

\input Tail

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "datacondAPI"
%%% End: 
